﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows.Forms;

namespace UnhandledThreadExceptions
{
    static class Program
    {
        /// <summary>
        /// アプリケーションのメイン エントリ ポイントです。
        /// </summary>
        [STAThread]
        static void Main()
        {
            // メインのUI スレッドで発生したすべての例外に対する
            // イベントハンドラを追加する
            Application.ThreadException +=
            new System.Threading.ThreadExceptionEventHandler(OnThreadException);
            // アプリケーションドメイン内のメインのUI スレッドを除くすべてのスレッドに
            // 対してイベントハンドラを追加する
            AppDomain.CurrentDomain.UnhandledException +=
            new UnhandledExceptionEventHandler(CurrentDomain_UnhandledException);
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            Application.Run(new Form1());
        }
        
        // UI スレッド以外の例外を処理する
        static void CurrentDomain_UnhandledException(object sender,
        UnhandledExceptionEventArgs e)
        {
            // 単に例外情報を表示する
            MessageBox.Show("CurrentDomain_UnhandledException: "
            + e.ExceptionObject.ToString());
        }
        // UI スレッドで発生する例外を処理する
        static void OnThreadException(object sender, System.Threading.ThreadExceptionEventArgs e)
        {
            // 単に例外情報を表示する
            MessageBox.Show("OnThreadException: " + e.Exception.ToString());
        }
    }
}
